Subject: Re: [PATCH] doc: explain the use of color.pager

From: Junio C Hamano <[email-masked]>
Date: Thu, 20 May 2021 15:36:59 +0900

Jonathan Nieder <[email-masked]> writes:

>> The current documentation for color.pager is technically correct, but
>> slightly misleading and doesn't really clarify the purpose of the
>> variable. As explained in the original thread which added it:
>>
>>   https://lore.kernel.org/git/[email-masked]/
>>
>> the point is deal with pagers that don't understand colors.
>
> Missing "to" before "deal".

Will locally amend.

> More importantly, I think I'd find a
> reference to the commit or a quotation from the affected user more
> helpful than a reference to the mailing list archive, since that would
> make this a bit more self-contained.

The original commit and its log message we ended up with did not
explain the motivation behind well enough.

The motivation from the original thread:

      When I use a pager that escapes the escape character or highlights the
      content itself the output of git diff without the pager should have
      colors but not with the pager.  For example using git diff with a
      pathspec is quite short most of the time.  For git diff I have to
      enable paging manually and run git diff | $PAGER usually but git log
      uses the pager automatically and should not use colors with it.

can be quoted as a whole, but "the point is to deal with ..." is a
succinct summary that is good enough for the purpose of this commit,
I would think.

>> +	A boolean to specify whether `auto` color modes should colorize
>> +	output going to the pager. Defaults to true; set this to false
>> +	if your pager does not understand ANSI color codes.
>
> I quite like the "set this to false if your pager does not understand
> ANSI color codes" part --- short and to the point.
>
> The sentence before takes me long enough to understand that I don't
> think we've gotten the wording right yet.  Before I suggest some
> wording, let's make sure I understand the behavior correctly:
>
> - unlike other color.* settings, this can only be "true" or "false".
>   It cannot be "auto".

Correct.

> - in other color.* settings, "auto" means "colors are used only when
>   stderr goes to a terminal".  A pager typically ultimately writes to
>   a terminal, but (1) it's not guaranteed to (e.g., xless writes to
>   its own window instead) and (2) more importantly for us, it's not
>   guaranteed to write terminal escapes as is.

Correct---color.pager is about telling Git about the pager's capability.

> - so this setting can be used to answer "for the sake of evaluating
>   color settings, should we treat output that is going to a pager as
>   going to a terminal?"

I am not sure if that is the easiest-to-explain way to view it.
It's more like "color.diff says 'auto', so we'd color it when the
output is going to tty and the terminal is not dumb.  We'd also
color it when our output is not directly going to tty (because we
are writing to a pipe whose other end is being read by the pager)
but we know we are talking to a pager, BUT the pager may not be able
to handle coloured output correctly---so we need a way to say "no,
even though our output goes to the pager, we cannot colour the
output".

> If I understood correctly, how about some text like the following?
>
> 	A boolean to specify whether `auto` color modes should colorize
> 	output going to a pager, in addition to their behavior of
> 	colorizing output going to a terminal. Defaults to true; [etc]

The variable has no control over what happens to output that
directly goes to a terminal, so while the additional phrase might
not be technically wrong per-se, I do not see why this is more clear
than the original.

So, in short, I think it would be sufficient to amend the proposed
log message with s/deal with/to deal with/ and nothing else.

Thanks.